
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <proto/datatypes.h>
#include <datatypes/pictureclass.h>

long min (long a,long b) {return (a < b ? a : b);}

int main (void)

{
struct RDArgs *rdargs;
static struct {
	char *file;
	char *pubscreen;
	} args = {NULL};
int rc = RETURN_ERROR;
struct Screen *scr;
Object *o;
struct BitMapHeader *bmhd;
struct BitMap *bm;
long winw,winh;
long winx,winy;
struct Window *win;
BOOL cont;
struct IntuiMessage *mess;

if (rdargs = ReadArgs ("FILE/A,PUBSCREEN/K",(APTR)&args,NULL))
	{
	if (scr = LockPubScreen (args.pubscreen))
		{

		if (o = NewDTObject (args.file,
				DTA_GroupID,GID_PICTURE,
				PDTA_Remap,TRUE,
				PDTA_Screen,scr,
				TAG_END))

			{
			DoDTMethod (o,NULL,NULL,DTM_PROCLAYOUT,NULL,TRUE);

			GetDTAttrs (o,
				PDTA_BitMapHeader,&bmhd,
				PDTA_DestBitMap,&bm,
				TAG_END);

			winw = min(scr->Width,  bmhd->bmh_Width);
			winh = min(scr->Height, bmhd->bmh_Height);
			winx = (scr->Width  - winw) >> 1;
			winy = (scr->Height - winh) >> 1;

			if (win = OpenWindowTags (NULL,
					WA_CustomScreen,scr,
					WA_Left,winx,
					WA_Top,winy,
					WA_Width,winw,
					WA_Height,winh,
					WA_Flags,WFLG_BORDERLESS|WFLG_ACTIVATE,
					WA_IDCMP,IDCMP_MOUSEBUTTONS|IDCMP_VANILLAKEY,
					TAG_END))
				{
				BltBitMapRastPort (bm,0,0,win->RPort,0,0,winw,winh,0xC0);

				rc = RETURN_OK;

				cont = TRUE;
				do	{
					WaitPort (win->UserPort);
					while (mess = (struct IntuiMessage *)GetMsg (win->UserPort))
						{
						switch (mess->Class)
							{
						case IDCMP_MOUSEBUTTONS:
							if (mess->Code == IECODE_LBUTTON)
								cont = FALSE;
							break;
						case IDCMP_VANILLAKEY:
							if (mess->Code == 0x1b) /* Esc */
								cont = FALSE;
							break;
							}
						ReplyMsg ((struct Message *)mess);
						}
					}
				while (cont);

				CloseWindow (win);
				}

			DisposeDTObject (o);
			}

		UnlockPubScreen (NULL,scr);
		}

	FreeArgs (rdargs);
	}

PrintFault (IoErr(),NULL);
return (rc);
}

